/*
 * SuperOffersView.java
 *
 * Created on 10 de agosto de 2004, 17:56
 */

package com.fenalco.servlets.shopkeeper;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.Store;
import com.fenalco.entities.SuperOfferList;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.lists.SuperOfferListViewShopKeeper;

/**
 * Este servlet carga la lista de superofertas disponibles en el sistema PVL
 * para el minorista como una instancia de <CODE>SuperOfferList</CODE> y
 * construye una vista (<CODE>SuperOferListView</CODE>) que es enviada a la
 * página superofertas.jsp como atributo <CODE>superOffersList</CODE>
 * 
 * @author Mario Linares Vásquez
 */
public class SuperOffersView extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 * @throws ServletException
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destructor de el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa solicitudes para los métodos HTTP <code>GET</code> y
	 * <code>POST</code>. Este método crea una instancia de la clase <CODE>
	 * SuperOfferList</CODE> con el id del usuario tomado de la sesión. Con
	 * esta lista se crea la vista como instancia de la clase <CODE>
	 * SuperOfferListView</CODE> y se agrega al <CODE>response</CODE> como
	 * atribvuto con nombre <CODE>view</CODE>. El flujo se redirecciona a
	 * superofertas.jsp
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		String url = "/minorista/superofertas.jsp";
		String message = "";
        HttpSession session = request.getSession( false );

	    try
	    {
	        if( session != null && ( User )session.getAttribute( "user" ) != null && ( ( User )session.getAttribute( "user" ) ).getRoleId() == 3 )
			{
				User user = (User) request.getSession().getAttribute("user");
				int storeId = ((Store) request.getSession().getAttribute("store"))
						.getId();
				SuperOfferList list = new SuperOfferList(user.getCompanyId(), 1,
						storeId);
	
				//filtrar lista de superofertas para mostrar solo las activas (no
				// vencidas)
				list.filter(1);
				//filtrar lista de superofertas para mostrar solo aquellas que
				// tengan escalas
				list.filterValids(storeId);
	
				SuperOfferListViewShopKeeper view = new SuperOfferListViewShopKeeper(
						list);
	
				request.setAttribute("view", view);
	
			}
			else
			{
				message = MessageBuilder.buildMessage(15);
				url = "/index.jsp";
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }
		request.setAttribute("message", message);
		RequestDispatcher dispatcher = getServletContext()
				.getRequestDispatcher(url);
		dispatcher.forward(request, response);

	}

	/**
	 * Procesa el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Procesa el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Retorna una breve descripción de el servlet.
	 * 
	 * @return
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}